--- old/usr/src/cmd/hal/utils/fsutils.c	2014-05-05 22:34:22.472339699 +0100
+++ new/usr/src/cmd/hal/utils/fsutils.c	2014-05-05 22:34:22.480083961 +0100
@@ -5,6 +5,8 @@
  * Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
  *
+ * Copyright 2014 Andrew Stormont.
+ *
  * Licensed under the Academic Free License version 2.1
  *
  */
@@ -33,22 +35,31 @@
 
 /*
  * Separates dos notation device spec into device and drive number
+ *     pN partition names are rewritten to point to p0
+ *     :N partition names are dropped
  */
 boolean_t
 dos_to_dev(char *path, char **devpath, int *num)
 {
-	char *p;
+	int i;
+	char *buf;
+	boolean_t found = B_FALSE;
 
-	if ((p = strrchr(path, ':')) == NULL) {
-		return (B_FALSE);
+	for (i = strlen(path); i > 0; i--) {
+		if (path[i] == 'p' || path[i] == ':') {
+			found = B_TRUE;
+			break;
+		}
 	}
-	if ((*num = atoi(p + 1)) == 0) {
+
+	if (found == B_FALSE || (*num = atoi(path + i + 1)) == 0 ||
+	    (buf = strdup(path)) == NULL) {
 		return (B_FALSE);
 	}
-	p[0] = '\0';
-	*devpath = strdup(path);
-	p[0] = ':';
-	return (*devpath != NULL);
+
+	(void) strcpy(buf + i, path[i] == 'p' ? "p0" : "");
+	*devpath = buf;
+	return (B_TRUE);
 }
 
 char *
